------------------------------------------------------------
-- WeaponPoison.lua
--
-- Abin
-- 2011/11/13
------------------------------------------------------------

if select(2, UnitClass("player")) ~= "ROGUE" then return end

local ipairs = ipairs
local GetItemCount = GetItemCount

local _, addon = ...
local L = addon.L

local spellList = {}
addon:BuildSpellList(spellList, 8679)
addon:BuildSpellList(spellList, 3408)
addon:BuildSpellList(spellList, 5760)
addon:BuildSpellList(spellList, 2818)
addon:BuildSpellList(spellList, 13218)

local function Button_UpdateQty(self)
	local data = spellList[self.index]
	if data then
		local qty = data.qty or 0
		local r, g, b = addon:GetGradientColor(qty, 20)
		self.icon:SetText(qty, r, g, b)
	end
end

local function Button_OnBagUpdate(self)
	if self.slot == 16 then
		local data
		for _, data in ipairs(spellList) do
			data.qty = GetItemCount(data.spell)
		end
	end
	Button_UpdateQty(self)
end

local function Button_OnTooltipRightText(self, tooltip)
	tooltip:AddLine(L["right click"]..L["remove weapon poison"], 1, 1, 1, 1)
end

local i
for i = 16, 18 do
	local button = addon:CreateActionButton("RogueWeaponPoision"..i, L["poisons"], nil, 3600, "WEAPON_ENCHANT")
	button.OnIndexChanged = Button_UpdateQty
	button.OnTooltipRightText = Button_OnTooltipRightText
	button.OnBagUpdate = Button_OnBagUpdate
	button:SetWeaponSlot(i)
	button:SetFlyProtect("type1", "item")
	button:SetScrollable(spellList, "item")

	-- This button shows up only when a throwing weapon is equipped
	if i == 18 then
		RegisterStateDriver(button, "visibility", "[equipped: "..select(14, GetAuctionItemSubClasses(1)).."] show; hide")
	end
end