------------------------------------------------------------
-- Totems.lua
--
-- Abin
-- 2011/12/13
------------------------------------------------------------

if select(2, UnitClass("player")) ~= "SHAMAN" then return end

local GetTotemInfo = GetTotemInfo

local _, addon = ...
local L = addon.L

local spellList = {}
addon:BuildSpellList(spellList, 66842)
addon:BuildSpellList(spellList, 66843)
addon:BuildSpellList(spellList, 66844)

local rightSpell = GetSpellInfo(36936)

local button = addon:CreateActionButton("ShamanTotems", L["totems"], nil, 300, "DUAL")
button.spell2 = rightSpell
button:SetAttribute("spell2", rightSpell)
button:SetFlyProtect()
button:SetScrollable(spellList, "spell1")
button:RequireSpell(66842)

function button:OnUpdateTimer(spell)
	local shortest, count = 0, 0
	local i
	for i = 1, 4 do
		local haveTotem, name, startTime, duration = GetTotemInfo(i)
		if haveTotem and (startTime or 0 ) > 0 and (duration or 0) > 0 then
			count = count + 1
			local expires = startTime + duration
			if shortest == 0 or expires < shortest then
				shortest = expires
			end
		end
	end

	if count == 4 then
		return 1, shortest
	elseif count > 0 then
		return -1, shortest
	end
end